#!/bin/bash
set -e

self_="$(readlink -f "$0")"
cmd_="../otsplit"

make
mkdir -p test
cd test

rm -f foo.*
"$cmd_" -s foo.{1..7} < "$self_"
"$cmd_" -j foo.* > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: random split failed"
  exit 1
fi
rm foo.*

dd if=/dev/urandom of=pad bs=1M count=5 2>/dev/null

rm -f foo
"$cmd_" -s -o pad foo < "$self_"
"$cmd_" -j foo pad > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: pre-existing pad split failed"
  exit 1
fi
rm foo

"$cmd_" -s -o pad - < "$self_" | "$cmd_" -j - pad > copy.txt
if ! diff -q "$self_" copy.txt
then
  echo "error: piping failed"
  exit 1
fi



# cd --
echo "all tests passed"
exit 0
